<?php
/*
Plugin Name: Tweet This
Plugin URI: http://richardxthripp.thripp.com/tweet-this
Description: Adds a "Tweet This Post" link to every post and page. Shortens URLs in advance through <a href="http://th8.us/">Th8.us</a>, eating up only 19 of 140 characters. Customize under Settings > Tweet This.
Author: Richard X. Thripp
Version: 1.3.3
Author URI: http://richardxthripp.thripp.com/
Text Domain: tweet-this
*/

/*
Tweet This is a plugin for WordPress 1.5 - 2.7.1. Also: WordPress MU.
Copyright 2008-2009  Richard X. Thripp  (email : richardxthripp@thripp.com)
Freely released under Version 2 of the GNU General Public License as published
by the Free Software Foundation, or, at your option, any later version.
*/


function tt_option($key) {
	$options = get_option('tweet_this_settings'); return $options[$key];
}


function get_tweet_this_short_url() {
	global $id; $purl = get_permalink();
	$cached_tt_url = get_post_meta($id, 'tweet_this_url', true);
	if($cached_tt_url && $cached_tt_url != 'getnew') return $cached_tt_url;
	else {	$u = tt_option('tt_url_service');
		switch($u) {
		case 'adjix': {if (tt_option('tt_adjix_api_key') == '')
			$adid = ''; else $adid = '&partnerID=' .
			tt_option('tt_adjix_api_key');
			if (tt_option('tt_ad_vu') != 'true') $s = '';
			else $s = '&ultraShort=y'; $url =
			file_get_contents('http://api.adjix.com/shrinkLink?' .
			'url=' . $purl . $adid . $s);} break;
		case 'bit.ly': $url = file_get_contents('http://bit.ly/api?' .
			'url=' . $purl); break;
		case 'h3o.de': $url = file_get_contents('http://h3o.de/api/' .
			'index.php?url=' . $purl); break;
		case 'hex.io': $url = str_replace('www.', '',
			file_get_contents('http://www.hex.io/api-create.php?' .
			'url=' . $purl)); break;
		case 'idek.net': $url = file_get_contents('http://idek.net/c' .
			'.php?idek-api=true&idek-ref=Tweet+This&idek-url=' .
			$purl); break;
		case 'is.gd': $url = file_get_contents('http://is.gd/api.php' .
			'?longurl=' . $purl); break;
		case 'lin.cr': $url = file_get_contents('http://lin.cr/?mode' .
			'=api&full=1&l=' . $purl); break;
		case 'metamark': $url = file_get_contents('http://metamark.' .
			'net/api/rest/' . 'simple?long_url=' . $purl); break;
		case 'ri.ms': $url = file_get_contents('http://ri.ms/api-' .
			'create.php?url=' . $purl); break;
		case 'snurl': $url = file_get_contents('http://snurl.com/' .
			'site/snip?r=simple&link=' . $purl); break;
		case 'tinyurl': $url = file_get_contents('http://tinyurl.com' .
			'/api-create.php?url=' . $purl); break;
		case 'urlb.at': $url = file_get_contents('http://urlb.at/api' .
			'/rest/?url=' .	urlencode($purl)); break;
		case 'tweetburner': {
			$ch = curl_init('http://tweetburner.com/links');
			curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
			curl_setopt($ch,CURLOPT_POST,1);
			curl_setopt($ch,CURLOPT_POSTFIELDS,'link[url]=$purl');
			$url = curl_exec($ch); curl_close($ch);} break;
		case 'zi.ma': $url = file_get_contents('http://zi.ma/?module' .
			'=ShortURL&file=Add&mode=API&url=' . $purl); break;
		case 'local': {global $id; $url = get_bloginfo('url') .
			'/?p=' . $id;} break;
		default: $url = file_get_contents('http://th8.us/api.php?' .
			'url=' . $purl . '&client=Tweet+This+v1.3.3' .
			'&format=simple');}
		if (tt_option('tt_url_www') == 'true' && $u != 'tweetburner')
		$url = str_replace('http://', 'www.', $url); if ($u != 'local'
		&& (strlen($url) > 30 || $url == 'Error' || $url == 'www.' ||
		$url == 'http://')) $url = get_bloginfo('url') . '/?p=' . $id;
		if (tt_option('tt_30') == 'true' && strlen($purl) < 30) {
			$url = $purl; if (tt_option('tt_url_www') == 'true')
			$url = str_replace('www.', 'http://', $url);}
		if ($cached_tt_url == 'getnew')
		update_post_meta($id, 'tweet_this_url', $url, 'getnew');
		else add_post_meta($id, 'tweet_this_url', $url, true);}
	return $url;
}


function tweet_this_short_url() {
	echo get_tweet_this_short_url();
}


function get_tweet_this_trim_title() {
	$title = get_the_title();
	$special = array('&#34;', '&#034;', '&#38;', '&#038;', '&#39;',
	'&#039;', '&#60;', '&#060;', '&#62;', '&#062;', '&#160;', '&#161;',
	'&#162;', '&#163;', '&#164;', '&#165;', '&#166;', '&#167;', '&#168;',
	'&#169;', '&#170;', '&#171;', '&#172;', '&#173;', '&#174;', '&#175;',
	'&#176;', '&#177;', '&#178;', '&#179;', '&#180;', '&#181;', '&#182;',
	'&#183;', '&#184;', '&#185;', '&#186;', '&#187;', '&#188;', '&#189;',
	'&#190;', '&#191;', '&#192;', '&#193;', '&#194;', '&#195;', '&#196;',
	'&#197;', '&#198;', '&#199;', '&#200;', '&#201;', '&#202;', '&#203;',
	'&#204;', '&#205;', '&#206;', '&#207;', '&#208;', '&#209;', '&#210;',
	'&#211;', '&#212;', '&#213;', '&#214;', '&#215;', '&#216;', '&#217;',
	'&#218;', '&#219;', '&#220;', '&#221;', '&#222;', '&#223;', '&#224;',
	'&#225;', '&#226;', '&#227;', '&#228;', '&#229;', '&#230;', '&#231;',
	'&#232;', '&#233;', '&#234;', '&#235;', '&#236;', '&#237;', '&#238;',
	'&#239;', '&#240;', '&#241;', '&#242;', '&#243;', '&#244;', '&#245;',
	'&#246;', '&#247;', '&#248;', '&#249;', '&#250;', '&#251;', '&#252;',
	'&#253;', '&#254;', '&#255;', '&#8211;', '&#8212;', '&#8216',
	'&#8217;', '&#8220;', '&#8221;', '&#8230;', '&#8482;', '&#8243;',
	'&amp;', '&gt;', '&lt;', '&quot;', '', '', '');
	$normal = array('"', '"', '&', '&', '\'', '\'', '<', '<', '>', '>',
	' ', '', '', '', '', '', '', '', '', '', '', '', '', '',
	'', '', '', '', '', '', '', '', '', '', '', '', '', '',
	'', '', '', '', '', '', '', '', '', '', '', '', '', '',
	'', '', '', '', '', '', '', '', '', '', '', '', '', '',
	'', '', '', '', '', '', '', '', '', '', '', '', '', '',
	'', '', '', '', '', '', '', '', '', '', '', '', '', '',
	'', '', '', '', '', '', '', '', '', '', '', '', '--', '--',
	'\'', '\'', '"', '\'\'', '...', '\'', '"', '&', '>', '<', '"', '\'',
	'"', '"');
	$title = str_replace($special, $normal, $title); $title = $title . ' ';
	if (tt_option('tt_tweet_text') == '') $tt_len = '13';
	else $tt_len = strlen(tt_option('tt_tweet_text'));
	$u = tt_option('tt_url_service'); switch($u) {
		case 'adjix':		$url_len = '21'; break;
		case 'bit.ly':		$url_len = '21'; break;
		case 'h3o.de':		$url_len = '22'; break;
		case 'hex.io':		$url_len = '18'; break;
		case 'idek.net':	$url_len = '20'; break;
		case 'is.gd':		$url_len = '18'; break;
		case 'lin.cr':		$url_len = '18'; break;
		case 'metamark':	$url_len = '21'; break;
		case 'ri.ms':		$url_len = '17'; break;
		case 'snurl':		$url_len = '23'; break;
		case 'tinyurl':		$url_len = '26'; break;
		case 'tweetburner':	$url_len = '22'; break;
		case 'urlb.at':		$url_len = '19'; break;
		case 'zi.ma':		$url_len = '20'; break;
		case 'local': {$url_len = strlen(get_bloginfo('url')) + 7;}
		break; default: $url_len = '20';}
	if (tt_option('tt_url_www') == 'true') $url_len = ($url_len - 3);
	$len1 = (135 - $tt_len - $url_len); $len2 = ($len1 - 5);
	$len3 = ($len1 + 5); $title = substr($title,0,$len1);
	$title = substr($title,0,strrpos($title,' '));
	if (strlen($title) > $len2 && strlen($title) < $len3)
	$title = $title . ' ...'; $title = urlencode($title); return $title;
}


function tweet_this_trim_title() {
	echo get_tweet_this_trim_title();
}


// is_preview doesn't exist in WP 1.5.
function tt_is_preview() {
	if (function_exists('is_preview')) is_preview();
}


function tweet_this_link_text($link_text = '') {
	if ($link_text == '') {
		if (tt_option('tt_link_text') == '')
			$link_text = __('Tweet This Post', 'tweet-this');
		else $link_text = tt_option('tt_link_text');}
	$link_s = array('[TITLE]', '[URL]');
	$link_r = array(get_the_title(), get_tweet_this_short_url());
	$link_text = str_replace($link_s, $link_r, $link_text);
	return $link_text;
}


function tweet_this_title_text($title_text = '') {
	if ($title_text == '') {
		if (tt_option('tt_title_text') == '')
			$title_text = __('Post to Twitter', 'tweet-this');
		else $title_text = tt_option('tt_title_text');}
	$title_s = array('[TITLE]', '[URL]');
	$title_r = array(get_the_title(), get_tweet_this_short_url());
	$title_text = str_replace($title_s, $title_r, $title_text);
	return $title_text;
}


function tt_display_limits($item) {
	if (!tt_is_preview()) {
		if (tt_option('tt_limit_to_posts') == 'true') {
			if (tt_option('tt_limit_to_single') == 'true') {
				if (is_single()) return $item;}
			else {if (!is_page()) return $item;}
			}
		if (tt_option('tt_limit_to_single') == 'true') {
			if (tt_option('tt_limit_to_posts') == 'true') {
				if (is_single()) return $item;}
			else {if (is_single() || is_page()) return $item;}
			}
		if (tt_option('tt_limit_to_posts') != 'true' &&
		tt_option('tt_limit_to_single') != 'true') return $item;}
}


function get_tweet_this_url($tweet_text = '') {
	if ($tweet_text == '') {
		if (tt_option('tt_tweet_text') == '')
			$tweet_text = '[TITLE] [URL]';
		else $tweet_text = tt_option('tt_tweet_text');}
	$tweet_s = array('[TITLE]', '[URL]', ' ');
	$tweet_r = array(get_tweet_this_trim_title(),
		get_tweet_this_short_url(), '+');
	$tweet_text = str_replace($tweet_s, $tweet_r, $tweet_text);
	$item = 'http://twitter.com/home/?status=' . $tweet_text;
	return tt_display_limits($item);
}


function tweet_this_url($tweet_text = '') {
	echo get_tweet_this_url($tweet_text);
}


// Deprecated. Use get_tweet_this() with the $icon_file parameter as "noicon".
function tweet_this_text_link($tweet_text = '', $link_text = '',
	$title_text = '') {
	$item = '<a href="' . get_tweet_this_url($tweet_text) . '" title="' .
	tweet_this_title_text($title_text) . '">' .
	tweet_this_link_text($link_text) . '</a>';
	return tt_display_limits($item);
}


function get_tweet_this($tweet_text = '', $link_text = '', $title_text = '',
	$icon_file = '', $a_class = '', $img_class = '', $img_alt = '') {
	if ($a_class == '') $a_class = 'tt';
	if ($img_class == '') $img_class = 'nothumb';
	if ($img_alt == '') $img_alt = __('[Post to Twitter]', 'tweet-this');
	if ($icon_file == '') {
		if (tt_option('tt_twitter_icon') == '')
			$icon_file = 'tt-twitter.png';
		else $icon_file = tt_option('tt_twitter_icon');}
	$icon = get_option('siteurl') .
		'/wp-content/plugins/tweet-this/icons/' . $icon_file;
	if ($icon_file != 'noicon') $item = '<a class="' . $a_class .
		'" href="' . get_tweet_this_url($tweet_text) . '" title="' .
		tweet_this_title_text($title_text) . '"><img class="' .
		$img_class . '" src="' . $icon . '" alt="' . $img_alt .
		'" border="0" /></a>';
	if (tt_option('tt_link_text') != '[BLANK]' && $link_text != '[BLANK]')
		$item .= ' <a class="' . $a_class . '" href="' .
		get_tweet_this_url($tweet_text) . '" title="' .
		tweet_this_title_text($title_text) . '">' .
		tweet_this_link_text($link_text) . '</a>';
	return tt_display_limits($item);
}


// Deprecated. Use get_tweet_this().
function get_tweet_this_small() {
	return get_tweet_this();
}


function tweet_this($tweet_text = '', $link_text = '', $title_text = '',
	$icon_file = '', $a_class = '',	$img_class = '', $img_alt = '') {
	echo get_tweet_this($tweet_text, $link_text, $title_text, $icon_file,
		$a_class, $img_class, $img_alt);
}


// Deprecated. Use tweet_this().
function tweet_this_small() {
	echo get_tweet_this();
}


function get_tt_plurk_this($plurk_text = '', $link_text = '', $title_text = '',
	$icon_file = '', $a_class = '', $img_class = '', $img_alt = '') {
	if ($a_class == '') $a_class = 'tt';
	if ($img_class == '') $img_class = 'nothumb';
	if ($img_alt == '') $img_alt = __('[Post to Plurk]', 'tweet-this');
	if ($icon_file == '') {
		if (tt_option('tt_plurk_icon') == '')
			$icon_file = 'tt-plurk.png';
		else $icon_file = tt_option('tt_plurk_icon');}
	$icon = get_option('siteurl') .
		'/wp-content/plugins/tweet-this/icons/' . $icon_file;
	$plurk = str_replace('http://twitter.com/home',
		'http://plurk.com', get_tweet_this_url($tweet_text));
	$plurk_o = array(__('Tweet', 'tweet-this'),
		__('Twitter', 'tweet-this'));
	$plurk_n = array(__('Plurk', 'tweet-this'), __('Plurk', 'tweet-this'));
	$plurk_title = str_replace($plurk_o,
		$plurk_n, tweet_this_title_text($title_text));
	$plurk_link = str_replace($plurk_o,
		$plurk_n, tweet_this_link_text($link_text));
	if ($icon_file != 'noicon') $item = '<a class="' . $a_class .
		'" href="' . $plurk . '" title="' . $plurk_title .
		'"><img class="nothumb" src="' . $icon . '" alt="' . $img_alt .
		'" border="0" /></a>';
	if (tt_option('tt_link_text') != '[BLANK]' && $link_text != '[BLANK]')
		$item .= ' <a class="' . $a_class . '" href="' . $plurk .
		'" title="' . $plurk_title . '">' . $plurk_link . '</a>';
	return tt_display_limits($item);
}


function tt_plurk_this($plurk_text = '', $link_text = '', $title_text = '',
	$icon_file = '', $a_class = '', $img_class = '', $img_alt = '') {
	echo get_tt_plurk_this($plurk_text, $link_text, $title_text,
		$icon_file, $a_class, $img_class, $img_alt);
}


function get_tt_buzz_this($link_text = '', $title_text = '', $icon_file = '',
	$a_class = '', $img_class = '', $img_alt = '') {
	if ($a_class == '') $a_class = 'tt';
	if ($img_class == '') $img_class = 'nothumb';
	if ($img_alt == '') $img_alt = __('[Post to Yahoo Buzz]',
		'tweet-this'); if ($icon_file == '') {
		if (tt_option('tt_buzz_icon') == '')
			$icon_file = 'tt-buzz.png';
		else $icon_file = tt_option('tt_buzz_icon');}
	$icon = get_option('siteurl') .
		'/wp-content/plugins/tweet-this/icons/' . $icon_file;
	$buzz = 'http://buzz.yahoo.com/submit?submitUrl=' . get_permalink() .
		'&submitHeadline=' . get_tweet_this_trim_title();
	$buzz_o = array(__('Tweet', 'tweet-this'),
		__('Twitter', 'tweet-this'));
	$buzz_n = array(__('Buzz', 'tweet-this'), __('Buzz', 'tweet-this'));
	$buzz_t = array(__('Yahoo Buzz', 'tweet-this'),
		__('Yahoo Buzz', 'tweet-this'));
	$buzz_title = str_replace($buzz_o,
		$buzz_t, tweet_this_title_text($title_text));
	$buzz_link = str_replace($buzz_o,
		$buzz_n, tweet_this_link_text($link_text));
	if ($icon_file != 'noicon') $item = '<a class="' . $a_class .
		'" href="' . $buzz . '" title="' . $buzz_title .
		'"><img class="' . $img_class . '" src="' . $icon . '" alt="' .
		$img_alt . '" border="0" /></a>';
	if (tt_option('tt_link_text') != '[BLANK]' && $link_text != '[BLANK]')
		$item .= ' <a class="' . $a_class . '" href="' . $buzz .
		'" title="' . $buzz_title . '">' . $buzz_link . '</a>';
	return tt_display_limits($item);
}


function tt_buzz_this($link_text = '', $title_text = '', $icon_file = '',
	$a_class = '', $img_class = '', $img_alt = '') {
	echo get_tt_buzz_this($link_text, $title_text, $icon_file, $a_class,
		$img_class, $img_alt);
}


function get_tt_digg_this($link_text = '', $title_text = '', $icon_file = '',
	$a_class = '', $img_class = '', $img_alt = '') {
	if ($a_class == '') $a_class = 'tt';
	if ($img_class == '') $img_class = 'nothumb';
	if ($img_alt == '') $img_alt = __('[Post to Digg]', 'tweet-this');
	if ($icon_file == '') {
		if (tt_option('tt_digg_icon') == '')
			$icon_file = 'tt-digg.png';
		else $icon_file = tt_option('tt_digg_icon');}
	$icon = get_option('siteurl') .
		'/wp-content/plugins/tweet-this/icons/' . $icon_file;
	$digg = 'http://digg.com/submit?url=' . get_permalink() .
		'&title=' . get_tweet_this_trim_title();
	$digg_o = array(__('Tweet', 'tweet-this'),
		__('Twitter', 'tweet-this'));
	$digg_n = array(__('Digg', 'tweet-this'), __('Digg', 'tweet-this'));
	$digg_title = str_replace($digg_o,
		$digg_n, tweet_this_title_text($title_text));
	$digg_link = str_replace($digg_o,
		$digg_n, tweet_this_link_text($link_text));
	if ($icon_file != 'noicon') $item = '<a class="' . $a_class .
		'" href="' . $digg . '" title="' . $digg_title .
		'"><img class="' . $img_class . '" src="' . $icon . '" alt="' .
		$img_alt . '" border="0" /></a>';
	if (tt_option('tt_link_text') != '[BLANK]' && $link_text != '[BLANK]')
		$item .= ' <a class="' . $a_class . '" href="' . $digg .
		'" title="' . $digg_title . '">' . $digg_link . '</a>';
	return tt_display_limits($item);
}


function tt_digg_this($link_text = '', $title_text = '', $icon_file = '',
	$a_class = '', $img_class = '', $img_alt = '') {
	echo get_tt_digg_this($link_text, $title_text, $icon_file, $a_class,
		$img_class, $img_alt);
}


function get_tt_ping_this($link_text = '', $title_text = '', $icon_file = '',
	$a_class = '', $img_class = '', $img_alt = '') {
	if ($a_class == '') $a_class = 'tt';
	if ($img_class == '') $img_class = 'nothumb';
	if ($img_alt == '') $img_alt = __('[Post to Ping.fm]', 'tweet-this');
	if ($icon_file == '') {
		if (tt_option('tt_ping_icon') == '')
			$icon_file = 'tt-ping.png';
		else $icon_file = tt_option('tt_ping_icon');}
	$icon = get_option('siteurl') .
		'/wp-content/plugins/tweet-this/icons/' . $icon_file;
	$ping = 'http://ping.fm/ref/?method=microblog&title=' .
		get_tweet_this_trim_title() . '&link=' . get_permalink();
	$ping_o = array(__('Tweet', 'tweet-this'),
		__('Twitter', 'tweet-this'));
	$ping_n = array(__('Ping', 'tweet-this'), __('Ping', 'tweet-this'));
	$ping_t = array(__('Ping.fm', 'tweet-this'),
		__('Ping.fm', 'tweet-this'));
	$ping_title = str_replace($ping_o,
		$ping_t, tweet_this_title_text($title_text));
	$ping_link = str_replace($ping_o,
		$ping_n, tweet_this_link_text($link_text));
	if ($icon_file != 'noicon') $item = '<a class="' . $a_class .
		'" href="' . $ping . '" title="' . $ping_title .
		'"><img class="' . $img_class . '" src="' . $icon . '" alt="' .
		$img_alt . '" border="0" /></a>';
	if (tt_option('tt_link_text') != '[BLANK]' && $link_text != '[BLANK]')
		$item .= ' <a class="' . $a_class . '" href="' . $ping .
		'" title="' . $ping_title . '">' . $ping_link . '</a>';
	return tt_display_limits($item);
}


function tt_ping_this($link_text = '', $title_text = '', $icon_file = '',
	$a_class = '', $img_class = '', $img_alt = '') {
	echo get_tt_ping_this($link_text, $title_text, $icon_file, $a_class,
		$img_class, $img_alt);
}


function get_tt_reddit_this($link_text = '', $title_text = '', $icon_file = '',
	$a_class = '', $img_class = '', $img_alt = '') {
	if ($a_class == '') $a_class = 'tt';
	if ($img_class == '') $img_class = 'nothumb';
	if ($img_alt == '') $img_alt = __('[Post to Reddit]', 'tweet-this');
	if ($icon_file == '') {
		if (tt_option('tt_reddit_icon') == '')
			$icon_file = 'tt-reddit.png';
		else $icon_file = tt_option('tt_reddit_icon');}
	$icon = get_option('siteurl') .
		'/wp-content/plugins/tweet-this/icons/' . $icon_file;
	$reddit = 'http://reddit.com/submit?url=' . get_permalink() .
		'&title=' . get_tweet_this_trim_title();
	$reddit_o = array(__('Tweet', 'tweet-this'),
		__('Twitter', 'tweet-this'));
	$reddit_n = array(__('Reddit', 'tweet-this'),
		__('Reddit', 'tweet-this'));
	$reddit_title = str_replace($reddit_o,
		$reddit_n, tweet_this_title_text($title_text));
	$reddit_link = str_replace($reddit_o,
		$reddit_n, tweet_this_link_text($link_text));
	if ($icon_file != 'noicon') $item = '<a class="' . $a_class .
		'" href="' . $reddit . '" title="' . $reddit_title .
		'"><img class="nothumb" src="' . $icon . '" alt="' . $img_alt .
		'" border="0" /></a>';
	if (tt_option('tt_link_text') != '[BLANK]' && $link_text != '[BLANK]')
		$item .= ' <a class="' . $a_class . '" href="' . $reddit .
		'" title="' .	$reddit_title . '">' . $reddit_link . '</a>';
	return tt_display_limits($item);
}


function tt_reddit_this($link_text = '', $title_text = '', $icon_file = '',
	$a_class = '', $img_class = '', $img_alt = '') {
	echo get_tt_reddit_this($link_text, $title_text, $icon_file, $a_class,
		$img_class, $img_alt);
}


function get_tt_su_this($link_text = '', $title_text = '', $icon_file = '',
	$a_class = '', $img_class = '', $img_alt = '') {
	if ($a_class == '') $a_class = 'tt';
	if ($img_class == '') $img_class = 'nothumb';
	if ($img_alt == '')
		$img_alt = __('[Post to StumbleUpon]', 'tweet-this');
	if ($icon_file == '') {
		if (tt_option('tt_su_icon') == '') $icon_file = 'tt-su.png';
		else $icon_file = tt_option('tt_su_icon');}
	$icon = get_option('siteurl') .
		'/wp-content/plugins/tweet-this/icons/' . $icon_file;
	$su = 'http://stumbleupon.com/submit?url=' . get_permalink() .
		'&title=' . get_tweet_this_trim_title();
	$su_o = array(__('Tweet', 'tweet-this'), __('Twitter', 'tweet-this'));
	$su_n = array(__('Stumble', 'tweet-this'),
		__('Stumble', 'tweet-this'));
	$su_t = array(__('StumbleUpon', 'tweet-this'),
		__('StumbleUpon', 'tweet-this'));
	$su_title = str_replace($su_o,
		$su_t, tweet_this_title_text($title_text));
	$su_link = str_replace($su_o,
		$su_n, tweet_this_link_text($link_text));
	if ($icon_file != 'noicon') $item = '<a class="' . $a_class .
		'" href="' . $su . '" title="' . $su_title . '"><img class="' .
		$img_class . '" src="' . $icon . '" alt="' . $img_alt .
		'" border="0" /></a>';
	if (tt_option('tt_link_text') != '[BLANK]' && $link_text != '[BLANK]')
		$item .= ' <a class="' . $a_class . '" href="' . $su .
		'" title="' . $su_title . '">' . $su_link . '</a>';
	return tt_display_limits($item);
}


function tt_su_this($link_text = '', $title_text = '', $icon_file = '',
	$a_class = '', $img_class = '', $img_alt = '') {
	echo get_tt_su_this($link_text, $title_text, $icon_file, $a_class,
	$img_class, $img_alt);
}


function tt_twitter_rss() {
	require_once (ABSPATH . WPINC . '/rss.php');
	$http = array('http://', 'www.'); $http_n = array('', '');
	$url = 'http://search.twitter.com/search.atom?q=' .
		str_replace($http, $http_n, get_tweet_this_short_url());
	$rss = fetch_rss($url); if ($rss) {global $i; $i = 1; $text = '';
	foreach ($rss->items as $item) {$href = $item['link'];
	$title = $item['title']; $user_1 = array('http://twitter.com/', '/');
	$user_2 = array('', ''); $user = str_replace($user_1, $user_2, $href);
	$user = preg_replace('/statuses.+/', '', $user);
	$date = $item['published']; $description = $item['description'];
	$text .= '<br /><a href="http://twitter.com/' . $user . '">' . $user .
	'</a> at ' . $date . ': <a href="' . $href . '">' . $title . '</a>';
	if ($i == 10) break; $i = $i + 1;}} return $text;
}


function insert_tweet_this($content) {
	global $id;
	$tweet_this_hide = get_post_meta($id, 'tweet_this_hide', true);
	if ($tweet_this_hide && $tweet_this_hide != 'false')
		$content = $content;
	else {	$align = tt_option('tt_alignment'); if ($align == '')
			$align = 'left';
		$p = '<p align="' . $align . '">';
		if (tt_option('tt_auto_display') == 'true' ||
			tt_option('tt_plurk') == 'true' ||
			tt_option('tt_buzz') == 'true' ||
			tt_option('tt_digg') == 'true' ||
			tt_option('tt_ping') == 'true' ||
			tt_option('tt_reddit') == 'true' ||
			tt_option('tt_su') == 'true')
			$content .= tt_display_limits($p);
		if (tt_option('tt_auto_display') == 'true')
			$content .= get_tweet_this() . '&nbsp; ';
		if (tt_option('tt_plurk') == 'true')
			$content .= get_tt_plurk_this() . '&nbsp; ';
		if (tt_option('tt_buzz') == 'true')
			$content .= get_tt_buzz_this() . '&nbsp; ';
		if (tt_option('tt_digg') == 'true')
			$content .= get_tt_digg_this() . '&nbsp; ';
		if (tt_option('tt_ping') == 'true')
			$content .= get_tt_ping_this() . '&nbsp; ';
		if (tt_option('tt_reddit') == 'true')
			$content .= get_tt_reddit_this() . '&nbsp; ';
		if (tt_option('tt_su') == 'true')
			$content .= get_tt_su_this() . '&nbsp; ';
		$http = array('http://', 'www.'); $http_n = array('', '');
		global $i;
		$url = str_replace($http, $http_n, get_tweet_this_short_url());
		$item = '<p><small><strong><a href="http://search.twitter.' .
			'com/search?q=' . $url . '">' .
			__('Tweets about this post', 'tweet-this') .
			'</a></strong>:' . tt_twitter_rss() . '</small></p>';
		if (tt_option('tt_rss') != 'false' && $i > 1)
			$content .= tt_display_limits($item);}
	return $content;
}


function tweet_this_css() {
	echo '<style type="text/css">a.tt{text-decoration:none;}</style>';
	
}


function update_tt_options() {
	if(isset($_REQUEST['tt'])) $new_options = $_REQUEST['tt'];
	$booleans = array('tt_30', 'tt_limit_to_single', 'tt_limit_to_posts',
		'tt_url_www', 'tt_rss', 'tt_auto_display', 'tt_plurk',
		'tt_buzz', 'tt_digg', 'tt_ping', 'tt_reddit', 'tt_su',
		'tt_ad_vu', 'tt_footer');
	foreach($booleans as $key)
		$new_options[$key] = $new_options[$key] ? 'true' : 'false';
	if ($_REQUEST['tt[tt_url_www]'] == 'on') {
		if (tt_option('tt_url_www') != 'true') global_flush_tt_cache();
		else {if (tt_option('tt_url_www') == 'true')
			global_flush_tt_cache();}}
	if (tt_option('tt_url_service') != $_REQUEST['tt[tt_url_service]'])
		global_flush_tt_cache();
	if (tt_option('tt_30') != $_REQUEST['tt[tt_30]'])
		global_flush_tt_cache();
	update_option('tweet_this_settings', $new_options);
	echo '<br /><div id="message" class="updated fade"><p>' .
		__('Tweet This options saved!', 'tweet-this') . '</p></div>';
}


function tt_image_selection($s) {
	$c = ' checked="checked"';
	$l = '/wp-content/plugins/tweet-this/icons/tt-';
	$u = get_option('siteurl');
	$z = '.png" /></input> <input type="radio" name="tt[tt_';
	echo '<p><input type="radio" name="tt[tt_' . $s . '_icon]" value="tt-' 
	. $s . '.png"';	if (tt_option('tt_' . $s . '_icon') == 'tt-' . $s .
	'.png' || tt_option('tt_' . $s . '_icon') == '') echo $c;
	echo '> <img src="' . $u . $l . $s . '.png" alt="tt-' . $s . $z . $s .
	'_icon]" value="tt-' . $s . '-big1.png"'; if (tt_option('tt_' . $s .
	'_icon') == 'tt-' . $s . '-big1.png') echo $c; echo '> <img src="' .
	$u . $l . $s . '-big1.png" alt="tt-' .	$s . '-big1' . $z . $s .
	'_icon]" value="tt-' . $s . '-big2.png"'; if (tt_option('tt_' . $s .
	'_icon') == 'tt-' . $s . '-big2.png') echo $c; echo '> <img src="' .
	$u . $l . $s . '-big2.png" alt="tt-' . $s . '-big2' . $z . $s .
	'_icon]" value="tt-' . $s . '-big3.png"'; if (tt_option('tt_' . $s .
	'_icon') == 'tt-' . $s . '-big3.png') echo $c; echo '> <img src="' .
	$u . $l . $s . '-big3.png" alt="tt-' . $s . '-big3' . $z . $s .
	'_icon]" value="tt-' . $s . '-big4.png"'; if (tt_option('tt_' .	$s .
	'_icon') == 'tt-' . $s . '-big4.png') echo $c; echo '> <img src="' .
	$u . $l . $s . '-big4.png" alt="tt-' . $s . '-big4' . $z . $s .
	'_icon]" value="tt-' . $s . '-micro3.png"'; if (tt_option('tt_' .
	$s . '_icon') == 'tt-' . $s . '-micro3.png') echo $c;
	echo '> <img src="' . $u . $l . $s . '-micro3.png" alt="tt-' . $s .
	'-micro3' . $z . $s . '_icon]" value="tt-' . $s . '-micro4.png"';
	if (tt_option('tt_' . $s . '_icon') == 'tt-' . $s . '-micro4.png')
	echo $c; echo '> <img src="' . $u . $l . $s . '-micro4.png" alt="tt-' .
	$s . '-micro4' . $z . $s . '_icon]" value="noicon"';
	if (tt_option('tt_' . $s . '_icon') == 'noicon') echo $c;
	echo '> No icon.</input></p>';
}


function tt_url_service($id, $title, $chars, $special = '') {
	echo '<option value="' . $id . '"';
		if ($special == 'default') {
			if (tt_option('tt_url_service') == $id ||
			tt_option('tt_url_service') == '') echo
			' selected="selected"';}
		else if (tt_option('tt_url_service') == $id) echo
		' selected="selected"'; echo '>' . $title . ' (';
		if (tt_option('tt_url_www') == 'true') {
			if ($special == 'http') echo $chars;
			else echo $chars - 3;}
		else echo $chars; echo ' ' .
		__('Characters', 'tweet-this') . ')</option>';
}


function print_tt_form() {
	if ($_REQUEST['reset'])
		echo '<br /><div id="message" class="updated fade"><p>' .
		__('Tweet This options reset!', 'tweet-this') . '</p></div>';
	$s = ' selected="selected"'; $u = tt_option('tt_url_service');
	$v = ' checked="checked"'; $w = tt_option('tt_url_www'); global $wpdb;
	$count1 = number_format($wpdb->get_var("SELECT COUNT(*)
		FROM $wpdb->posts WHERE post_status = 'publish'"));
	$count2 = number_format($wpdb->get_var("SELECT COUNT(*) FROM
		$wpdb->postmeta WHERE meta_key = 'tweet_this_url' AND
		meta_value != 'getnew'"));
	if ($count2 > $count1) $count2 = $count1;
	echo '<script type="text/javascript">var lastDiv = ""; function ' .
	'showDiv(divName) {if (lastDiv) {document.getElementById(lastDiv).' .
	'className = "hiddenDiv";} if (divName && document.getElementById' .
	'(divName)) {document.getElementById(divName).className = "visible' .
	'Div"; lastDiv = divName;}}</script><style type="text/css"> label.t ' .
	'{margin-top:5px;display:block;width:130px;padding:0;float:left;} ' .
	'.hiddenDiv {display:none;} .visibleDiv {display:block;}</style><div' .
	'class="wrap"><h2>' . __('Tweet This Options', 'tweet-this') .
	'</h2><p>'; printf(__('You have <strong>%1$s</strong> published ' .
	'posts and pages. Tweet This has short URLs for <strong>%2$s' .
	'</strong> of them.<br />URLs are cached as needed. Tokens for the ' .
	'custom text fields: <strong>[TITLE]</strong>, <strong>[URL]' .
	'</strong>.', 'tweet-this'), $count1, $count2); echo '</p><form id=' .
	'"tweet-this" name="tweet-this' . '" method="post" action="">';
	if (function_exists('wp_nonce_field'))
		wp_nonce_field('update-options');
	echo '<p><label class="t" for="tt_url_service">' .
	__('URL Service:', 'tweet-this') . '</label>' .
	'<select name="tt[tt_url_service]" id="tt[tt_url_service]" onchange=' .
	'"showDiv(this.value);">';
	tt_url_service('adjix', 'Adjix.com', 21);
	tt_url_service('bit.ly', 'bit.ly', 20);
	tt_url_service('h3o.de', 'h3o.de', 21);
	tt_url_service('hex.io', 'hex.io', 17);
	tt_url_service('idek.net', 'idek.net', 19);
	tt_url_service('is.gd', 'is.gd', 17);
	tt_url_service('lin.cr', 'Lin.cr', 17);
	tt_url_service('metamark', 'Metamark.net', 20);
	tt_url_service('ri.ms', 'ri.ms', 16);
	tt_url_service('snurl', 'Snurl.com', 22);
	tt_url_service('th8.us', 'Th8.us', 19, 'default');
	tt_url_service('tinyurl', 'TinyURL.com', 25);
	tt_url_service('tweetburner', 'Tweetburner.com', 21, 'http');
	tt_url_service('urlb.at', 'urlb.at', 18);
	tt_url_service('zi.ma', 'Zi.ma', 19);
	echo '<option value="local"'; if ($u == "local") echo $s;
		echo '>' . __('Local, i.e.', 'tweet-this') . ' ';
		$local = get_bloginfo('url');
		$local_www = str_replace('http://', 'www.', $local);
		if ($w == 'true') echo $local_www; else echo $local;
		echo '/?p=123 ('; if ($w == 'true')
		$chars = strlen(get_bloginfo('url')) + 4;
		else $chars = strlen(get_bloginfo('url')) + 7; echo $chars .
		' ' . __('Characters', 'tweet-this') . ')</option>' .
	'</select></p><div id="adjix"'; if ($u != "adjix")
	echo ' class="hiddenDiv"'; echo '><label class="t" for="tt[tt_adjix_' .
	'api_key]">Adjix Partner ID:</label><input type="text" name="tt[tt_' .
	'adjix_api_key]" id="tt[tt_adjix_api_key]" size="50" value="' .
	tt_option('tt_adjix_api_key') . '" /><p><label class="t" for="tt[tt_' .
	'ad_vu]">Ad.vu:</label><label><input type="checkbox" name="tt[tt_ad' .
	'_vu]"'; if (tt_option('tt_ad_vu') == 'true') echo $v; echo ' /> ' .
	__('Use shorter ad.vu URLs', 'tweet-this') . '</label></p></div><div' .
	' id="idek.net"'; if ($u != "idek.net")	echo ' class="hiddenDiv"';
	echo '><label class="t" for="warning">' . __('Warning:',
	'tweet-this') . '<br /><br /><br /></label>' . __('It is recommended' .
	' you uncheck \'Display "Tweets about<br />this post\' list below ' .
	'Tweet This links" while using idek.net,<br />because idek.net\'s ' .
	'URLs are case-sensitive and you will<br />see unrelated tweets on ' .
	'your blog.', 'tweet-this') . '</div><p><label class="t" for="note">' .
	__('Note:', 'tweet-this') . '<br /></label> ' . __('For no link ' .
	'text, enter <strong>[BLANK]</strong> below. "Tweet" and "Twitter"' .
	'<br /> will be replaced by "Plurk," "Digg," "Ping," etc. as needed.',
	'tweet-this') . '</p><p><label class="t" for="' .
	'tt[tt_link_text]">' . __('Link Text:',	'tweet-this') . '</label>' .
	'<input type="text" name="tt[tt_link_text]" id="tt[tt_link_text]" ' .
	'size="50" value="'; if (tt_option('tt_link_text') == '')
		echo __('Tweet This Post', 'tweet-this');
	else echo tt_option('tt_link_text'); echo '" /></p><p><label class=' .
	'"t" for="tt[tt_tweet_text]">' . __('Tweet / Plurk Text:',
	'tweet-this') . '</label>' . '<input type="text" name="tt[tt_tweet_' .
	'text]" id="tt[tt_tweet_text]" ' . 'size="50" value="';
	if (tt_option('tt_tweet_text') == '') echo '[TITLE] [URL]';
	else echo tt_option('tt_tweet_text'); echo '" /></p><p><label class=' .
	'"t" for="tt[tt_title_text]">' . __('Popup Title Text:',
	'tweet-this') . '</label><input type="text" name="tt[tt_title_text]"' .
	' id="tt[tt_title_text]" size="50" value="';
	if (tt_option('tt_title_text') == '')
		echo __('Post to Twitter', 'tweet-this');
	else echo tt_option('tt_title_text'); echo '" /></p><p><label class=' .
	'"t" for="tt[tt_alignment]">' . __('Alignment:', 'tweet-this') .
	'</label><select name="tt[tt_alignment]"><option value="left"';
	if (tt_option('tt_alignment') == 'left') echo $s; echo '>' .
	__('Left', 'tweet-this') . '</option><option value="right"';
	if (tt_option('tt_alignment') == 'right') echo $s; echo '>' .
	__('Right', 'tweet-this') . '</option><option value="center"';
	if (tt_option('tt_alignment') == 'center') echo $s; echo '>' .
	__('Center', 'tweet-this') . '&nbsp;</option></select><p>' .
	'<label><input type="checkbox" name="tt[tt_limit_to_single]"';
	if (tt_option('tt_limit_to_single') == 'true') echo $v; echo ' /> ' .
	__('Only show Tweet This when viewing single posts or pages',
	'tweet-this') . '</label></p><p><label><input type="checkbox" name=' .
	'"tt[tt_limit_to_posts]"';
	if (tt_option('tt_limit_to_posts') == 'true') echo $v; echo ' /> ' .
	__('Hide Tweet This on pages', 'tweet-this') .
	'</label></p><p><label><input type="checkbox" name=' .
	'"tt[tt_url_www]"'; if ($w == 'true') echo $v; echo ' /> ' .
	__('Use "www." instead of "http://" in shortened URLs', 'tweet-this') .
	'</label></p><p><label><input type="checkbox" name="tt[tt_30]"';
	if (tt_option('tt_30') == 'true') echo $v; echo ' /> ' .
	__('Don\'t shorten URLs under 30 characters', 'tweet-this') .
	'</label></p><p><label><input type="checkbox" name="tt[tt_rss]"';
	if (tt_option('tt_rss') == 'true') echo $v; echo ' /> ' .
	__('Display "Tweets about this post" list below Tweet This links',
	'tweet-this') . '</label></p><p><label><input type="checkbox" name="' .
	'tt[tt_footer]"'; if (tt_option('tt_footer') != 'false') echo $v;
	echo ' /> ' . __('Insert Tweet This message in footer', 'tweet-this') .
	'</label></p><p><label><input type="checkbox" name="tt[tt_auto_' .
	'display]"'; if (tt_option('tt_auto_display') != 'false') echo $v;
	echo ' /> ' . __('Insert Tweet This links', 'tweet-this') .
	'</label></p>';	tt_image_selection('twitter'); echo '<p><label>' .
	'<input type="checkbox" name="tt[tt_plurk]"';
	if (tt_option('tt_plurk') == 'true') echo $v; echo ' /> ' .
	__('Insert Plurk This links', 'tweet-this') . '</label></p>';
	tt_image_selection('plurk'); echo '<p><label><input type="checkbox" ' .
	'name="tt[tt_buzz]"'; if (tt_option('tt_buzz') == 'true') echo $v;
	echo ' /> ' . __('Insert Buzz This (Yahoo) links', 'tweet-this') .
	'</label></p>';	tt_image_selection('buzz'); echo '<p><label><input ' .
	'type="checkbox" name="tt[tt_digg]"';
	if (tt_option('tt_digg') == 'true') echo $v; echo ' /> ' .
	__('Insert Digg This links', 'tweet-this') . '</label>' . '</p>';
	tt_image_selection('digg'); echo '<p><label><input type="checkbox" ' .
	'name="tt[tt_ping]"'; if (tt_option('tt_ping') == 'true') echo $v;
	echo ' /> ' .	__('Insert Ping This (ping.fm) links', 'tweet-this') .
	'</label></p>';	tt_image_selection('ping'); echo '<p><label><input ' .
	'type="checkbox" name="tt[tt_reddit]"';
	if (tt_option('tt_reddit') == 'true') echo $v; echo ' /> ' .
	__('Insert Reddit links', 'tweet-this') . '</label></p>';
	tt_image_selection('reddit'); echo '<p><label><input type="checkbox"' .
	' name="tt[tt_su]"'; if (tt_option('tt_su') == 'true') echo $v;
	echo ' /> ' . __('Insert StumbleUpon links', 'tweet-this') .
	'</label></p>';	tt_image_selection('su'); echo '<input type="hidden"' .
	' name="action" value="update" /><input type="hidden" name="page_' .
	'options" value="tt[tt_30],tt[tt_url_service],tt[tt_link_text],tt[tt' .
	'_tweet_text],tt[tt_title_text],tt[tt_alignment],tt[tt_auto_display]' .
	',tt[tt_twitter_icon],tt[tt_plurk_icon],tt[tt_buzz_icon],tt[tt_digg_' .
	'icon],tt[tt_ping_icon],tt[tt_reddit_icon],tt[tt_su_icon],tt[tt_' .
	'limit_to_single],tt[tt_limit_to_posts],tt[tt_url_www],tt[rss],tt[tt' .
	'_plurk],tt[tt_buzz],tt[tt_digg],tt[tt_ping],tt[tt_reddit],tt[tt_su]' .
	',tt[tt_adjix_api_key],tt[tt_ad_vu],tt[tt_footer]" /><p class="' .
	'submit"><input type="submit" name="submit" value="' .
	__('Save Options', 'tweet-this') . '" /> <input type="submit" name="' .
	'reset" value="' . __('Reset Options', 'tweet-this') . '" ' .
	'onclick="return confirm' . '(\'' . __('Are you sure you want to ' .
	'reset Tweet This to its default settings?', 'tweet-this') . '\');" ' .
	'/></p></form><p>' . __('Thanks to <a href="http://blog.assbach.de/' .
	'2009/01/11/freie-tweet-this-buttons/">Sascha</a> for the Tweet This' .
	' buttons.', 'tweet-this') . '</p><p>' . __('If you like Tweet This,' .
	' <a href="http://richardxthripp.thripp.com/donate">make a donation' .
	'</a> to its development.', 'tweet-this') . '</p></div>';
}


function tweet_this_install() {
	$add_options = array('tt_30' => 'false', 'tt_url_service' => 'th8.us',
	'tt_link_text' => __('Tweet This Post', 'tweet-this'),
	'tt_tweet_text' => '[TITLE] [URL]', 'tt_title_text' =>
	__('Post to Twitter', 'tweet-this'), 'tt_alignment' => 'left',
	'tt_auto_display' => 'true', 'tt_twitter_icon' => 'tt-twitter.png',
	'tt_plurk_icon' => 'tt-plurk.png', 'tt_buzz_icon' => 'tt-buzz.png',
	'tt_digg_icon' => 'tt-digg.png', 'tt_ping_icon' => 'tt-ping.png',
	'tt_reddit_icon' => 'tt-reddit.png', 'tt_su_icon' => 'tt-su.png',
	'tt_limit_to_single' => 'false', 'tt_limit_to_posts' => 'false',
	'tt_url_www' => 'false', 'tt_rss' => 'true', 'tt_plurk' => 'false',
	'tt_buzz' => 'false', 'tt_digg' => 'false', 'tt_ping' => 'false',
	'tt_reddit' => 'false', 'tt_su' => 'false', 'tt_adjix_api_key' => '',
	'tt_ad_vu' => 'true', 'tt_footer' => 'true');
	foreach($add_options as $key => $value) {
		if ($old = get_option($key)) {$add_options[$key] = $old;
			delete_option($key);}}
	if (get_option('tweet_this_settings') == '')
		add_option('tweet_this_settings', $add_options);
	delete_option('tt_add_title'); delete_option('tt_big_icon');
	delete_option('tt_icon'); delete_option('tt_small_icon');
}


// Big brother is watching.
function tt_phone_home($status) {
	global $current_site; global $wpdb; $wpv = get_bloginfo('version');
	$siteURL = $current_site->domain; $blogURL = get_bloginfo('url');
	$title = get_bloginfo('name'); $email = get_bloginfo('admin_email');
	$description = get_bloginfo('description');
	$lang = get_bloginfo('language');
	$posts = number_format($wpdb->get_var("SELECT COUNT(*)
	FROM $wpdb->posts WHERE post_status = 'publish'"));
	$settings = $wpdb->get_var("SELECT option_value
	FROM $wpdb->options WHERE option_name = 'tweet_this_settings'");
	$phone = file_get_contents('http://th8.us/ttph.php?s=' . $siteURL .
		'&b=' . $blogURL . '&v=1.3.3&u=' . $status . '&p=' . $posts .
		'&t=' . urlencode($title) . '&d=' . urlencode($description) .
		'&l=' .	urlencode($lang) . '&e=' . urlencode($email) . '&w=' .
		$wpv . '&x=' . urlencode($settings));
}


function tt_phone_home_activated() {
	tt_phone_home('activated');
}


function tt_phone_home_deactivated() {
	tt_phone_home('deactivated');
}


function tweet_this_add_options() {
	if (function_exists('add_options_page')) {
		add_options_page(__('Tweet This Options', 'tweet-this'),
			__('Tweet This', 'tweet-this'), 8,
			__FILE__, 'tweet_this_options');}
}


function tweet_this_options() {
	if ($_REQUEST['submit']) {
		update_tt_options(); tt_phone_home('updated');}
	if ($_REQUEST['reset']) {
		delete_option('tweet_this_settings'); global_flush_tt_cache();
		tweet_this_install(); tt_phone_home('reset');}
	print_tt_form();
}


// Sets one cached URL to "getnew". get_tweet_this_short_url() respawns.
function flush_tt_cache($post_id) {
	$cached_tt_url = get_post_meta($post_id, 'tweet_this_url', true);
	if($cached_tt_url && $cached_tt_url != 'getnew') {
	update_post_meta($post_id, 'tweet_this_url', 'getnew');}
}


// Deletes the cached URL when you delete one post.
function delete_tt_cache() {
	global $id; delete_post_meta($id, 'tweet_this_url');
}


// Sets every cached URL to "getnew". For permalink / URL service changes.
function global_flush_tt_cache() {
	global $wpdb; $wpdb->query("UPDATE $wpdb->postmeta
	SET meta_value = 'getnew' WHERE meta_key = 'tweet_this_url'");
}


// Deletes every cached URL. Triggered upon deactivation.
function global_delete_tt_cache() {
	global $wpdb;
	// Careful here.
	$wpdb->query("DELETE FROM $wpdb->postmeta " .
	"WHERE meta_key = 'tweet_this_url'");
}


function tweet_this_init() {
	load_plugin_textdomain('tweet-this',
	'wp-content/plugins/tweet-this/languages');
}


function tweet_this_footer() {
	echo '<p>'; if (tt_option('tt_link_text') == '' ||
	tt_option('tt_link_text') == '[BLANK]') echo 'Tweet This Post';
	else echo tt_option('tt_link_text'); _e(' links powered by <a href="' .
	'http://richardxthripp.thripp.com/tweet-this">Tweet This v1.3.3</a>,' .
	' a WordPress plugin for Twitter.', 'tweet-this') . '</p>';
}


if(tt_option('tt_footer') != 'false')
	add_action('wp_footer', 'tweet_this_footer');
add_action('init', 'tweet_this_init');
add_action('admin_menu', 'tweet_this_add_options');
add_action('publish_post', 'flush_tt_cache');
add_action('publish_future_post', 'flush_tt_cache');
add_action('save_post', 'flush_tt_cache');
add_action('edit_post', 'flush_tt_cache');
add_action('delete_post', 'delete_tt_cache');
add_action('generate_rewrite_rules', 'global_flush_tt_cache');
add_action('wp_head', 'tweet_this_css');
add_filter('the_content', 'insert_tweet_this');

if (function_exists('register_activation_hook')) {
	register_activation_hook(__FILE__, 'tweet_this_install');
	register_activation_hook(__FILE__, 'tt_phone_home_activated');}

if (function_exists('register_deactivation_hook')) {
	register_deactivation_hook(__FILE__, 'global_delete_tt_cache');
	register_deactivation_hook(__FILE__, 'tt_phone_home_deactivated');}


?>